//+------------------------------------------------------------------+
//|                                                  mt_terminal.mq4 |
//|                                           Copyright  2011, albr |
//|                                                     albr@ukr.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, albr"
#property link      "albr@ukr.net"
#include <stderror.mqh>


extern bool ShowArrow4NewOrders = false; //    // 
extern int order_slippage = 3; //     

int magicnumber = 123; //      

/*   ( ) */
int g_accMaxLotSize = 0; //  -  .   .     .
double g_accMaxLotValue = 0; //     .   .     .
int g_currentLotSize = 0; //  -  .
double g_currentLotValue = 0; //     .
string g_set_curr = ""; //  

int g_totalordersH = 0; // -   
int g_FirstOrderTicketH = -1; //    

#import "mt_dll.dll"
   int init_dll(); 
   int deinit_dll();
   int prepare_write_dll();
   int write_dll(string);
   int commit_dll();   
   int get_orders_count_dll();
   string get_order_dll(int);
   int send_order_dll(string);   
#import


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{  
  init_dll();  
  g_totalordersH = 0; 
  g_FirstOrderTicketH = -1; 
  send_order_dll("hclear");
    
  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  deinit_dll();
  g_totalordersH = 0; 
  g_FirstOrderTicketH = -1; 
  return(0);
}
/*
aOrder:  OO LLLLL TTTTTTTTTT SSSSSSSSSSSSSSS PPPPPPPPPPPPPPP CCCCCCCC
         01 23456 7890123456 789012345678901 234567890123456 78901234
         

O 02[00 .. 01]: BN - buy now; SN - sell now; CN - Close now; BL - Buy Limit; BS - Buy Stop; SL - Sell Limit; SS - Sell Stop; CO - cancel order; MO - Modify Order;
                LS - max lots size; LV - max lots value;
L 05[02 .. 06]: lot size 5,2;
T 10[07 .. 16]: ticket no
S 15[17 .. 31]: stop lose 15
                max lot size; max lot value 
P 15[32 .. 46]: take profit 15
C 8 [47 .. 54]: currency
*/
int ParseOrder (string aOrder, int& aOrderType, double& aOrderValue, int& aOrderTicket, int& aOrderTP, int& aOrderSL, string& aCurrency)
{ 
  
  if (StringLen(aOrder)  < 7) return (1);
  
  int res = 0;
  
  string ordType = StringSubstr(aOrder, 0, 2);
  
  if (ordType == "BN")
  { 
    aOrderType = OP_BUY;
    aOrderValue = StrToDouble(StringTrimRight(StringSubstr(aOrder, 2, 5)))/100;    
    
    aOrderSL = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));    
    aOrderTP = StrToInteger(StringTrimRight(StringSubstr(aOrder, 32, 15))); 
    aCurrency = StringTrimRight(StringSubstr(aOrder, 47, 8));
    
  } else

  if (ordType == "SN")
  {
    aOrderType = OP_SELL;
    aOrderValue = StrToDouble(StringTrimRight(StringSubstr(aOrder, 2, 5)))/100;

    aOrderSL = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));    
    aOrderTP = StrToInteger(StringTrimRight(StringSubstr(aOrder, 32, 15)));        
    aCurrency = StringTrimRight(StringSubstr(aOrder, 47, 8));
  } else
  
  if (ordType == "CO")
  {
    aOrderType = -1;
    aOrderTicket = StrToInteger(StringTrimLeft(StringSubstr(aOrder, 7, 10)));
  } else
 
  if (ordType == "LS")
  {    //  -  .   .     .
    g_accMaxLotSize = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));
   
    res = 1;
  } else    
  
  if (ordType == "LV")
  {    //     .   .     .
    g_accMaxLotValue = StrToInteger(StringTrimRight(StringSubstr(aOrder, 17, 15)));        
    g_accMaxLotValue = g_accMaxLotValue / 100;
    res = 1;
  } else    
  
  if (ordType == "SC")
  {    // Set Currency
    g_set_curr = StringTrimRight(StringSubstr(aOrder, 7, 10));
    if (MarketInfo(g_set_curr, MODE_ASK) == 0) 
    {
      g_set_curr = "";   
    }
    
    res = 1;
  } else    
  
  if (ordType == "UH")
  {   
    g_totalordersH = 0; 
    g_FirstOrderTicketH = -1;     
        
    res = 1;
  } else    
  
  
  
  {
    res = 1;
  }
  return (res);
}

/* getCurrency -  */
string getCurrency(string aCCY)
{
  if (aCCY != "") {return (aCCY);}
  if (g_set_curr == "") {return (Symbol());}
  return (g_set_curr);  
}

double getCurrencyBid(string aCCY)
{
  return (MarketInfo(getCurrency(aCCY), MODE_BID));
}

double getCurrencyAsk(string aCCY)
{
  return (MarketInfo(getCurrency(aCCY), MODE_ASK));
}

double getCurrencyPoint(string aCCY)
{
  return (MarketInfo(getCurrency(aCCY), MODE_POINT));
}

void PrintError(string aErrM)
{
  if (StringLen(aErrM) > 0)
  {
    Print("err:",aErrM,".");
    send_order_dll("m"+aErrM);
  }
  
  return;
}

/*CheckOrder -     - 
  albr
*/
bool CheckOrder(int aOrderType, double aOrderValue)
{
  string l_last_error_message = "";

  if (g_accMaxLotSize > 0) 
  {
    if  (g_currentLotSize+1 > g_accMaxLotSize) 
    {
      l_last_error_message = "[" + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS ) + "]     -  .  = "+g_accMaxLotSize+".  - = "+g_currentLotSize;
      PrintError(l_last_error_message);
      return (false);
    }
  }
  
  if (g_accMaxLotValue > 0) 
  {
    if  (NormalizeDouble(g_currentLotValue+aOrderValue,2) > NormalizeDouble(g_accMaxLotValue,2)) 
    {
      
      l_last_error_message = "[" + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS ) + "]       .  = "+DoubleToStr(NormalizeDouble(g_accMaxLotValue ,2),2)
              +".   = "+DoubleToStr(NormalizeDouble(g_currentLotValue,2),2);
      PrintError(l_last_error_message);
      return (false);
    }
  }

  return (true);
}

/* apply_new_orders -   
  albr
*/
int apply_new_orders(string acc_num)
{
  int new_orders = get_orders_count_dll();
  int ticket = 0;
  string l_last_error_message = "";
  
  string lOrder;    
  if (new_orders > 0)
  {
    for (int i = 0; i<new_orders; i++)
    {
      RefreshRates();
      lOrder = get_order_dll(i);  
      
      int lOrderType; 
      double lOrderValue; 
      int lOrderTP;
      int lOrderSL;
      double lOrderTP_;
      double lOrderSL_;      
      int lOrderTicket;
      int lColorB = Green;
      int lColorS = Violet;
      string lCCY = "";
      string sOrd = "";      
      
      if (ShowArrow4NewOrders == false)
      {
        lColorB = CLR_NONE;
        lColorS = CLR_NONE;
      }
      
      if (ParseOrder (lOrder, lOrderType, lOrderValue, lOrderTicket, lOrderTP, lOrderSL, lCCY) == 0)
      {       
        
        if (lOrderType == OP_BUY && lOrderValue > 0) 
        {  
          if (CheckOrder(lOrderType, lOrderValue) == false) return (0);
          
          if (lOrderTP <= 0) 
            {lOrderTP_ = NULL;} else
            {lOrderTP_ = getCurrencyAsk(lCCY) + lOrderTP*getCurrencyPoint(lCCY);}
            
          if (lOrderSL <= 0) 
            {lOrderSL_ = NULL;} else
            {lOrderSL_ = getCurrencyAsk(lCCY) - lOrderSL*getCurrencyPoint(lCCY);}    
        
          ticket = OrderSend(getCurrency(lCCY), OP_BUY, lOrderValue, getCurrencyAsk(lCCY), order_slippage, lOrderSL_, lOrderTP_, NULL, magicnumber, 0, lColorB);
          sOrd = DoubleToStr(NormalizeDouble(lOrderValue ,2),2) + " BUY (#"+ticket+") "+getCurrency(lCCY);
        }
        else 
        if (lOrderType == OP_SELL && lOrderValue > 0) 
        {
          if (CheckOrder(lOrderType, lOrderValue) == false) return (0);
          
          if (lOrderTP <= 0) 
            {lOrderTP_ = NULL;} else
            {lOrderTP_ = getCurrencyBid(lCCY) - lOrderTP*getCurrencyPoint(lCCY);}
            
          if (lOrderSL <= 0) 
            {lOrderSL_ = NULL;} else
            {lOrderSL_ = getCurrencyBid(lCCY) + lOrderSL*getCurrencyPoint(lCCY);}    

          ticket = OrderSend(getCurrency(lCCY), OP_SELL, lOrderValue, getCurrencyBid(lCCY), order_slippage, lOrderSL_, lOrderTP_, NULL, magicnumber, 0, lColorB);
          sOrd = DoubleToStr(NormalizeDouble(lOrderValue ,2),2) + " SELL (#"+ticket+") "+getCurrency(lCCY);
        }
        else
        if (lOrderType == -1 && lOrderTicket > 0) 
        {         
            if(OrderSelect(lOrderTicket, SELECT_BY_TICKET, MODE_TRADES)==true)
            {              
              if(OrderType()==OP_BUY) 
              {    
                sOrd = DoubleToStr(NormalizeDouble(OrderLots() ,2),2) + " CLOSE BUY (#"+lOrderTicket+") "+DoubleToStr(NormalizeDouble(OrderProfit()+OrderSwap(),2),2)+" "+OrderSymbol();
                if (OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),order_slippage,lColorS)) PrintLastHistoryOrder(lOrderTicket);
              }
              else
              if(OrderType()==OP_SELL) 
              {
                sOrd = DoubleToStr(NormalizeDouble(OrderLots() ,2),2) + " CLOSE SELL (#"+lOrderTicket+") "+DoubleToStr(NormalizeDouble(OrderProfit()+OrderSwap(),2),2)+" "+OrderSymbol();
                if (OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),order_slippage,lColorS)) PrintLastHistoryOrder(lOrderTicket);
              }            
            }    
        }
        
        int err=GetLastError();
        if (StringLen(l_last_error_message) > 0) l_last_error_message = l_last_error_message + ";%%%";
        
        l_last_error_message = l_last_error_message + "[" + TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS ) + "] ";        
        
        if (err != ERR_NO_ERROR)
        {
          l_last_error_message = l_last_error_message + ErrorDescription(err);
        } 
          else
        {
          l_last_error_message = l_last_error_message + sOrd;          
         }

      }
    }
  }  
  
  PrintError(l_last_error_message);
  
  return (0);    
}

/* upload_account_info -     
  albr
*/  
int upload_account_info(string acc_num)
{  
  prepare_write_dll();
  write_dll("[ACCOUNT]="+acc_num);    
  write_dll("[BALANCE]="+DoubleToStr(NormalizeDouble(AccountBalance(),2),2));
  write_dll("[EQUITY]="+DoubleToStr(NormalizeDouble(AccountEquity(),2),2));
  write_dll("[PROFIT]="+DoubleToStr(NormalizeDouble(AccountEquity()-AccountBalance(),2),2));
  double lpoint = getCurrencyPoint("");
  if (lpoint == 0) 
  {    
    write_dll("[SPREAD]=0"); 
    write_dll("[DEFCCYASK]=0");
    write_dll("[DEFCCYBID]=0");
  
  } else
  {
    write_dll("[SPREAD]="+DoubleToStr((getCurrencyAsk("") - getCurrencyBid(""))/lpoint,0));
    write_dll("[DEFCCYASK]="+DoubleToStr(getCurrencyAsk("")/lpoint,0));
    write_dll("[DEFCCYBID]="+DoubleToStr(getCurrencyBid("")/lpoint,0));
  }
  write_dll("[DEFCCY]="+getCurrency(""));  
  
  
  
    
  int totalorders = OrdersTotal();
  g_currentLotSize = totalorders;
  g_currentLotValue = 0; 
  
  write_dll("[ORDERS]="+DoubleToStr(NormalizeDouble(totalorders,0),0));
    
  for (int i=0; i < totalorders; i++)
  { 
    if (OrderSelect(i, SELECT_BY_POS)) 
    {
      write_dll("[ORDER_"+i+"_TICKET]="+OrderTicket()); 
      write_dll("[ORDER_"+i+"_SYMBOL]="+OrderSymbol());           
      write_dll("[ORDER_"+i+"_TYPE]="+GetOrderTypeStr(OrderType()));        
      write_dll("[ORDER_"+i+"_LOTS]="+DoubleToStr(NormalizeDouble(OrderLots(),2),2));      
      g_currentLotValue = NormalizeDouble(g_currentLotValue + OrderLots(),2);
      write_dll("[ORDER_"+i+"_OPENTIME]="+TimeToStr(OrderOpenTime(),TIME_DATE|TIME_SECONDS));        
      write_dll("[ORDER_"+i+"_PROFIT]="+DoubleToStr(NormalizeDouble(OrderProfit(),2),2));
      write_dll("[ORDER_"+i+"_SWAP]="+DoubleToStr(NormalizeDouble(OrderSwap() ,2),2));
      write_dll("[ORDER_"+i+"_MAGIC]="+DoubleToStr(NormalizeDouble(OrderMagicNumber() ,0),0));
      
      write_dll("[ORDER_"+i+"_OPENPRICE]="+DoubleToStr(NormalizeDouble(OrderOpenPrice(), 5), 5));
    }       
  }    
  commit_dll(); 
  PrintHistoryOrders();  
  return (0);      
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{      
  apply_new_orders(AccountNumber());
  upload_account_info(AccountNumber());  
  return(0);
}
//+------------------------------------------------------------------+
string ErrorDescription(int err_code)
  {
   switch(err_code)
     {
      case 1: return("       ");
      case 2: return(" .        ");
      case 3: return("      ");
      case 4: return("  ");
      case 5: return("   ");
      case 6: return("    ");
      case 7: return(" ");
      case 8: return("  ");
      case 9: return("    ");
      case 64: return(" .      ");
      case 65: return("  .      ");
      case 128: return("    ");
      case 129: return("  bid  ask, ,  ");
      case 130: return("           (     )");
      case 131: return(" ,    ");
      case 132: return(" ");
      case 133: return(" ");
      case 134: return("    ");
      case 135: return(" ");
      case 136: return(" ");
      case 137: return(" ");
      case 138: return("  ,   bid  ask");
      case 139: return("    ");
      case 140: return("  .   SELL ");
      case 141: return("  ");
      case 142: return("   ");
      case 143: return("    ");
      case 144: return("       ");
      case 145: return(" ,          -   ");
      case 146: return("  .     ,   IsTradeContextBusy  FALSE.");
      case 147: return("     ");
      case 148: return("      ,  ");
      case 149: return("        ,   ");      
      case 4001: return("  ");
      case 4002: return("  -  ");
      case 4003: return("    ");
      case 4004: return("    ");
      case 4005: return("      ");
      case 4006: return("    ");
      case 4007: return("    ");
      case 4008: return(" ");
      case 4009: return("   ");
      case 4010: return("    ");
      case 4011: return("  ");
      case 4012: return("    ");
      case 4013: return("  ");
      case 4014: return(" ");
      case 4015: return(" ");
      case 4016: return(" ");
      case 4017: return(" DLL  ");
      case 4018: return("  ");
      case 4019: return("  ");
      case 4020: return("     ");
      case 4021: return("   ,   ");
      case 4022: return(" ");
      case 4050: return("   ");
      case 4051: return("   ");
      case 4052: return("   ");
      case 4053: return(" ");
      case 4054: return("  -");
      case 4055: return("  ");
      case 4056: return(" ");
      case 4057: return("   ");
      case 4058: return("   ");
      case 4059: return("     ");
      case 4060: return("  ");
      case 4061: return("  ");
      case 4062: return("   string");
      case 4063: return("   integer");
      case 4064: return("   double");
      case 4065: return("    ");
      case 4066: return("     ");
      case 4067: return("    ");
      case 4099: return(" ");
      case 4100: return("    ");
      case 4101: return("  ");
      case 4102: return("   ");
      case 4103: return("  ");
      case 4104: return("    ");
      case 4105: return("    ");
      case 4106: return(" ");
      case 4107: return("     ");
      case 4108: return("  ");
      case 4109: return("  .         ");
      case 4110: return("   .    ");
      case 4111: return("   .    ");
      case 4200: return("  ");
      case 4201: return("   ");
      case 4202: return("  ");
      case 4203: return("  ");
      case 4204: return("  ");
      case 4205: return("  ");
      case 4206: return("   ");
      case 4207: return("    ");
      default:   return(" : "+err_code);
     }
     return("");
  }
  
/* PrintHistoryOrders -      
  albr
*/ 
  void PrintHistoryOrders()
  { 
    int totalorders  = OrdersHistoryTotal();
    
    if (g_totalordersH == totalorders) 
    {
      if (totalorders > 0)
      {
        if(OrderSelect(0,SELECT_BY_POS, MODE_HISTORY))
        { 
          if (g_FirstOrderTicketH == OrderTicket()) return;
          g_FirstOrderTicketH = OrderTicket();
        }              
      } 
      else
      {
        g_FirstOrderTicketH = -1;
        return;
      }
    }
    g_totalordersH = totalorders;
    send_order_dll("hclear");
    
    
    for (int i=0; i < totalorders; i++)
    {
    
      if(OrderSelect(i,SELECT_BY_POS, MODE_HISTORY))
      {
        SendHistoryOrder();    
      }
    }
  }

/* PrintLastHistoryOrder -      
  albr
*/   
  void PrintLastHistoryOrder(int HistoryTicket)
  {    
    if(OrderSelect(HistoryTicket, SELECT_BY_TICKET, MODE_HISTORY))
    {
      g_totalordersH = g_totalordersH + 1;
      SendHistoryOrder();
    }    
  }
  
string GetOrderTypeStr(int aOrderType)  
{
  string ord_type;        
  switch(aOrderType)
  {
    case OP_BUY: ord_type = "BUY"; break;
    case OP_SELL: ord_type = "SELL"; break;
    case OP_BUYLIMIT: ord_type = "BUYLIMIT"; break;
    case OP_BUYSTOP: ord_type = "BUYSTOP"; break;
    case OP_SELLLIMIT: ord_type = "SELLLIMIT"; break;
    case OP_SELLSTOP: ord_type = "SELLSTOP"; break;
  }
  return (ord_type);
}

void SendHistoryOrder()
{
send_order_dll("h["+ DoubleToStr(NormalizeDouble(OrderLots() ,2),2)+ 
        "]["+ OrderMagicNumber()+
        "]["+ OrderTicket()+
        "]["+ OrderSymbol()+  
        "]["+ DoubleToStr(NormalizeDouble(OrderClosePrice(),5),5) +
        "]["+ TimeToStr(OrderCloseTime(),TIME_DATE|TIME_MINUTES)+
        "]["+ DoubleToStr(NormalizeDouble(OrderOpenPrice() ,5),5)+
        "]["+ TimeToStr(OrderOpenTime(),TIME_DATE|TIME_MINUTES)+
        "]["+ DoubleToStr(NormalizeDouble(OrderSwap() ,2),2)+
        "]["+ DoubleToStr(NormalizeDouble(OrderProfit() ,2),2)+
        "]["+ GetOrderTypeStr(OrderType())+
        "]"        
        );
  return;
}


